SystemOrganization addCategory: #WoodCutPictures!
SystemOrganization addCategory: #'WoodCutPictures-ComplexFunctions'!
SystemOrganization addCategory: #'WoodCutPictures-Core'!
SystemOrganization addCategory: #'WoodCutPictures-Functions'!
SystemOrganization addCategory: #'WoodCutPictures-Shows'!
SystemOrganization addCategory: #'WoodCutPictures-Squarelimit'!
SystemOrganization addCategory: #'WoodCutPictures-Tests'!

TestCase subclass: #WoodCutPictureDrawingTest
	instanceVariableNames: 'canvas evaluated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Tests'!

!WoodCutPictureDrawingTest class methodsFor: 'as yet unclassified' stamp: 'hjo 3/25/2008 17:39'!
drawOnWorld

	| canvas |
	canvas := World canvas.
	self suite run tests do: [: aTest | aTest drawOn: canvas ]! !

!WoodCutPictureDrawingTest class methodsFor: 'as yet unclassified' stamp: 'hjo 3/26/2008 10:40'!
generateTestableCanvasWithPolygonsFrom: arrayOfPoints 

	|answerCanvas|
	answerCanvas := TestableCanvas new.

	arrayOfPoints do: [:points |
		answerCanvas drawPolygon: points color: Color red borderWidth: 1 borderColor: Color black
	].
	^answerCanvas! !

!WoodCutPictureDrawingTest methodsFor: 'drawing-layout' stamp: 'hjo 3/25/2008 15:40'!
coordinatedFrame: coordination

	^self defaultFrame
		origin: (self frameOriginForCoordination: coordination)! !

!WoodCutPictureDrawingTest methodsFor: 'drawing-layout' stamp: 'HwaJong 10/28/2013 15:32'!
defaultFrame

	^WoodCutFrame new
		origin: 0@0;
		xVector: self frameSize@0;
		yVector: 0@self frameSize! !

!WoodCutPictureDrawingTest methodsFor: 'drawing' stamp: 'hjo 3/25/2008 15:37'!
drawOn: aFormCanvas 

	canvas showOn: aFormCanvas! !

!WoodCutPictureDrawingTest methodsFor: 'drawing-layout' stamp: 'hjo 3/25/2008 15:42'!
frameOriginForCoordination: coordination

	^ (coordination x  @ (coordination y * (1+self yMargin)) * self frameSize) truncated! !

!WoodCutPictureDrawingTest methodsFor: 'drawing-layout' stamp: 'hjo 3/25/2008 15:39'!
frameSize

	"size of default square frame size."
	^60! !

!WoodCutPictureDrawingTest methodsFor: 'private' stamp: 'hjo 3/26/2008 10:54'!
picture: aWoodCutPicture atCoordiation: aPoint yieldsPoints: anArray 
	
	self picture: aWoodCutPicture atCoordiation: aPoint yieldsPolygonsOfPoints: {anArray}  ! !

!WoodCutPictureDrawingTest methodsFor: 'as yet unclassified' stamp: 'hjo 7/3/2011 01:43'!
picture: aWoodCutPicture atCoordiation: aPoint yieldsPolygonsOfPoints: anArray 

	aWoodCutPicture drawOnCanvas: canvas usingFrame: (self coordinatedFrame: aPoint).
	self assert: 
		(self class generateTestableCanvasWithPolygonsFrom: anArray)
	equals: canvas! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/25/2008 17:33'!
test010F

	canvas := TestableCanvas new.
	self picture: WoodCutPicture f atCoordiation: 0@0 yieldsPoints: {17@8 . 42@8 . 42@17 . 25@17 . 25@25 . 34@25 . 34@34 . 25@34 . 25@51 . 17@51 . 17@8}! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/25/2008 17:31'!
test020Rotated

	canvas := TestableCanvas new.
	self picture: WoodCutPicture f rotated atCoordiation: 1@0 yieldsPoints:  {68@42 . 68@17 . 77@17 . 77@34 . 85@34 . 85@25 . 94@25 . 94@34 . 111@34 . 111@42 . 68@42}! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/25/2008 17:35'!
test030RotatedTwice

	canvas := TestableCanvas new.
	self picture: WoodCutPicture f rotated rotated atCoordiation: 2@0 yieldsPoints: {162@51 . 137@51 . 137@42 . 154@42 . 154@34 . 145@34 . 145@25 . 154@25 . 154@8 . 162@8 . 162@51}! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/25/2008 17:36'!
test040RotatedTripplly

	canvas := TestableCanvas new.
	self picture: WoodCutPicture f rotated rotated rotated atCoordiation: 3@0 yieldsPoints: {231@17 . 231@42 . 222@42 . 222@25 . 214@25 . 214@34 . 205@34 . 205@25 . 188@25 . 188@17 . 231@17}! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/25/2008 17:52'!
test050RotatedQuad

	canvas := TestableCanvas new.
	self picture: WoodCutPicture f rotated rotated rotated rotated atCoordiation: 4@0 yieldsPoints:  {257@8 . 282@8 . 282@17 . 265@17 . 265@25 . 274@25 . 274@34 . 265@34 . 265@51 . 257@51 . 257@8}! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/25/2008 17:55'!
test060Flipped

	canvas := TestableCanvas new. 
	self picture: WoodCutPicture f flipped  atCoordiation: 5@0 yieldsPoints:  {342@8 . 317@8 . 317@17 . 334@17 . 334@25 . 325@25 . 325@34 . 334@34 . 334@51 . 342@51 . 342@8}! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/25/2008 18:01'!
test070FlippedFlipped

	canvas := TestableCanvas new. 
	self picture: WoodCutPicture f flipped  atCoordiation: 6@0 yieldsPoints: {402@8 . 377@8 . 377@17 . 394@17 . 394@25 . 385@25 . 385@34 . 394@34 . 394@51 . 402@51 . 402@8}
! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/25/2008 18:07'!
test080FlipRot

	canvas := TestableCanvas new. 
	self picture: WoodCutPicture f flipped rotated atCoordiation: 0@1 yieldsPoints: {8@107 . 8@132 . 17@132 . 17@115 . 25@115 . 25@124 . 34@124 . 34@115 . 51@115 . 51@107 . 8@107}
! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/25/2008 18:21'!
test090Rot45

	canvas := TestableCanvas new. 
	self picture: WoodCutPicture f rotatedBy45Degrees atCoordiation: 1@1 yieldsPoints:  {72@85 . 85@72 . 90@77 . 81@85 . 85@90 . 90@85 . 94@90 . 90@94 . 98@102 . 94@107 . 72@85}
! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/25/2008 18:22'!
test100FlipRot45

	canvas := TestableCanvas new. 
	self picture: WoodCutPicture f rotatedBy45Degrees flipped atCoordiation: 2@1 yieldsPoints:  {167@85 . 154@72 . 150@77 . 158@85 . 154@90 . 150@85 . 145@90 . 150@94 . 141@102 . 145@107 . 167@85}
! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/26/2008 10:53'!
test110Over

	| f |
	canvas := TestableCanvas new.
	f := WoodCutPicture f.
	self picture: (f over: f rotated rotated)   atCoordiation: 3@1 yieldsPolygonsOfPoints: {{222@141 . 197@141 . 197@132 . 214@132 . 214@124 . 205@124 . 205@115 . 214@115 . 214@98 . 222@98 . 222@141} . {197@98 . 222@98 . 222@107 . 205@107 . 205@115 . 214@115 . 214@124 . 205@124 . 205@141 . 197@141 . 197@98}}
! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/26/2008 11:03'!
test120Above

	| f |
	canvas := TestableCanvas new.
	f := WoodCutPicture f.
	self picture: (f above: f)   atCoordiation: 4@1 yieldsPolygonsOfPoints:  {{257@94 . 282@94 . 282@98 . 265@98 . 265@102 . 274@102 . 274@107 . 265@107 . 265@115 . 257@115 . 257@94} . {257@124 . 282@124 . 282@128 . 265@128 . 265@132 . 274@132 . 274@137 . 265@137 . 265@145 . 257@145 . 257@124}}! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/26/2008 11:06'!
test130Above

	| f |
	canvas := TestableCanvas new.
	f := WoodCutPicture f.
	self picture: (f beside: f)   atCoordiation: 5@1 yieldsPolygonsOfPoints:  {{308@98 . 321@98 . 321@107 . 312@107 . 312@115 . 317@115 . 317@124 . 312@124 . 312@141 . 308@141 . 308@98} . {338@98 . 351@98 . 351@107 . 342@107 . 342@115 . 347@115 . 347@124 . 342@124 . 342@141 . 338@141 . 338@98}}! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/26/2008 11:08'!
test140Cycle

	| f |
	canvas := TestableCanvas new.
	f := WoodCutPicture f.
	self picture: f cycled  atCoordiation: 6@1 yieldsPolygonsOfPoints: {{368@94 . 381@94 . 381@98 . 372@98 . 372@102 . 377@102 . 377@107 . 372@107 . 372@115 . 368@115 . 368@94} . {415@98 . 415@111 . 411@111 . 411@102 . 407@102 . 407@107 . 402@107 . 402@102 . 394@102 . 394@98 . 415@98} . {364@141 . 364@128 . 368@128 . 368@137 . 372@137 . 372@132 . 377@132 . 377@137 . 385@137 . 385@141 . 364@141} . {411@145 . 398@145 . 398@141 . 407@141 . 407@137 . 402@137 . 402@132 . 407@132 . 407@124 . 411@124 . 411@145}}! !

!WoodCutPictureDrawingTest methodsFor: 'tests' stamp: 'hjo 3/26/2008 11:16'!
test150Nonet

	| f |
	canvas := TestableCanvas new.
	f := WoodCutPicture f.
	self picture: (PictureNonet new northWest: f; north: f; northEast: f; west: f; middle: f; east: f; southWest: f; south: f; southEast: f) atCoordiation: 7@1 yieldsPolygonsOfPoints:  {{425@92 . 434@92 . 434@95 . 428@95 . 428@98 . 431@98 . 431@101 . 428@101 . 428@107 . 425@107 . 425@92} . {445@92 . 454@92 . 454@95 . 448@95 . 448@98 . 451@98 . 451@101 . 448@101 . 448@107 . 445@107 . 445@92} . {465@92 . 474@92 . 474@95 . 468@95 . 468@98 . 471@98 . 471@101 . 468@101 . 468@107 . 465@107 . 465@92} . {425@112 . 434@112 . 434@115 . 428@115 . 428@118 . 431@118 . 431@121 . 428@121 . 428@127 . 425@127 . 425@112} . {445@112 . 454@112 . 454@115 . 448@115 . 448@118 . 451@118 . 451@121 . 448@121 . 448@127 . 445@127 . 445@112} . {465@112 . 474@112 . 474@115 . 468@115 . 468@118 . 471@118 . 471@121 . 468@121 . 468@127 . 465@127 . 465@112} . {425@132 . 434@132 . 434@135 . 428@135 . 428@138 . 431@138 . 431@141 . 428@141 . 428@147 . 425@147 . 425@132} . {445@132 . 454@132 . 454@135 . 448@135 . 448@138 . 451@138 . 451@141 . 448@141 . 448@147 . 445@147 . 445@132} . {465@132 . 474@132 . 474@135 . 468@135 . 468@138 . 471@138 . 471@141 . 468@141 . 468@147 . 465@147 . 465@132}}! !

!WoodCutPictureDrawingTest methodsFor: 'drawing-layout' stamp: 'hjo 3/25/2008 15:42'!
yMargin

	^0.5! !

Object subclass: #AbstractWoodCutPicture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Core'!

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 2/29/2008 20:47'!
above: aWoodCutPicture 

	^PictureAbovePicture new
		upPicture: self;
		downPicture: aWoodCutPicture! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 2/29/2008 20:51'!
beside: aWoodCutPicture 

	^PictureBesidePicture new
		leftPicture: self;
		rightPicture: aWoodCutPicture! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 21:20'!
buildCorner: aWoodCutPicture

	PictureQuartet new
		upperLeftPicture: self;
		upperRightPicture: "side"0;
		lowerLeftPicture: "side" 0 rotated;
		lowerRightPicture: aWoodCutPicture tileU! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 20:44'!
buildSide: aWoodCutPicture

	^PictureQuartet new
		upperLeftPicture: self;
		upperRightPicture: self;
		lowerLeftPicture: aWoodCutPicture rotated;
		lowerRightPicture: aWoodCutPicture	! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/9/2008 09:51'!
cycleOfOne

	^PictureCycle new picture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/9/2008 10:31'!
cycled

	^PictureCycle new picture: self! !

!AbstractWoodCutPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 10:47'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 
 
	self subclassResponsibility! !

!AbstractWoodCutPicture methodsFor: 'drawing' stamp: 'HwaJong 10/28/2013 15:32'!
drawOnWorld

	self drawOnCanvas: World canvas usingFrame: WoodCutFrame default! !

!AbstractWoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:00'!
expressionString

	^String streamContents: [:stream| self printExpressionOn: stream ]! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 2/29/2008 20:28'!
flipped

	^FlippedPicture new picture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 12:12'!
over: aWoodCutPicture 

	^PictureOverPicture new
		overPicture: self;
		underPicture: aWoodCutPicture! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 12:32'!
pattern2

	^self rotatedBy45Degrees flipped! !

!AbstractWoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 17:58'!
printExpressionOn: aStream

	self subclassResponsibility! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/9/2008 10:40'!
quartetOfOne

	^PictureQuartet new
		upperLeftPicture: self;
		upperRightPicture: self;
		lowerLeftPicture: self;
		lowerRightPicture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 2/29/2008 20:29'!
rotated
	
	^RotatedPicture new picture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 2/29/2008 20:52'!
rotatedBy45Degrees

	^RotatedBy45DegreesPicture new picture: self! !

!AbstractWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 3/13/2008 19:10'!
sierpinskiDepth

	^0! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/13/2008 19:36'!
sierpinskiForm

	^SierpinskiPicture new subPicture: self; blank: WoodCutPicture blank! !

!AbstractWoodCutPicture methodsFor: 'organizing' stamp: 'hjo 3/9/2008 13:59'!
simplified

	^self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/6/2008 16:48'!
tileTForm

	^WoodCutTileT new picture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/6/2008 16:48'!
tileUForm

	^WoodCutTileU new picture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/9/2008 10:38'!
tileVForm

	^WoodCutTileV new picture: self! !

!AbstractWoodCutPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 12:37'!
triplyRotated

	^self rotated rotated rotated! !

!AbstractWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 3/13/2008 19:04'!
unitPicture

	^self! !

AbstractWoodCutPicture subclass: #FunctionalWoodCutPicture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Core'!

!FunctionalWoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:48'!
functionName

	^self subclassResponsibility! !

!FunctionalWoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:49'!
parameterList

	"Answer an array of pictures used as parameters"
	^self subclassResponsibility! !

!FunctionalWoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:47'!
printExpressionOn: aStream

	aStream nextPutAll: self functionName.
	aStream nextPut: $(.
	
	self parameterList
		do: [:pict| pict printExpressionOn: aStream ] separatedBy: [ aStream nextPut: $, ].

	aStream nextPut: $)! !

FunctionalWoodCutPicture subclass: #PictureAbovePicture
	instanceVariableNames: 'upPicture downPicture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Functions'!

!PictureAbovePicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 20:32'!
downPicture: aWoodCutPicture 

	downPicture :=aWoodCutPicture! !

!PictureAbovePicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 10:30'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 

	upPicture drawOnCanvas: aCanvas usingFrame: aDaliotsFrame upHalf.
	downPicture drawOnCanvas:aCanvas usingFrame: aDaliotsFrame downHalf ! !

!PictureAbovePicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:02'!
functionName 

	^'above'! !

!PictureAbovePicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:04'!
parameterList

	^{ upPicture. downPicture }! !

!PictureAbovePicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 20:32'!
upPicture: aWoodCutPicture 

	upPicture := aWoodCutPicture! !

PictureAbovePicture subclass: #WeightedPictureAbovePicture
	instanceVariableNames: 'upWeight downWeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Functions'!

!WeightedPictureAbovePicture methodsFor: 'accessing' stamp: 'hjo 3/6/2008 10:02'!
downWeight: aNumber

	downWeight := aNumber! !

!WeightedPictureAbovePicture methodsFor: 'drawing' stamp: 'hjo 3/6/2008 12:00'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 

	| weightedYVector |
	weightedYVector := aDaliotsFrame yVectorWeightedBy: upWeight and: downWeight.
	upPicture drawOnCanvas: aCanvas usingFrame: (aDaliotsFrame upPart: weightedYVector).
	downPicture drawOnCanvas: aCanvas usingFrame: (aDaliotsFrame downPart: weightedYVector)! !

!WeightedPictureAbovePicture methodsFor: 'accessing' stamp: 'hjo 3/6/2008 10:01'!
upWeight: aNumber

	upWeight := aNumber! !

FunctionalWoodCutPicture subclass: #PictureBesidePicture
	instanceVariableNames: 'leftPicture rightPicture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Functions'!

!PictureBesidePicture methodsFor: 'drawing' stamp: 'hjo 3/5/2008 17:14'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 

	leftPicture drawOnCanvas: aCanvas usingFrame: aDaliotsFrame leftHalf.
	rightPicture drawOnCanvas: aCanvas usingFrame: aDaliotsFrame rightHalf! !

!PictureBesidePicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:05'!
functionName

	^'beside'! !

!PictureBesidePicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 05:32'!
leftPicture: aWoodCutPicture 

	leftPicture :=aWoodCutPicture! !

!PictureBesidePicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:06'!
parameterList

	^{ leftPicture. rightPicture }! !

!PictureBesidePicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 05:32'!
rightPicture: aWoodCutPicture 

	rightPicture :=aWoodCutPicture! !

PictureBesidePicture subclass: #WeightedPictureBesidePicture
	instanceVariableNames: 'leftWeight rightWeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Functions'!

!WeightedPictureBesidePicture methodsFor: 'drawing' stamp: 'hjo 3/6/2008 11:58'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 

	| weightedXVector |
	weightedXVector := aDaliotsFrame xVectorWeightedBy: leftWeight and: rightWeight.
	leftPicture drawOnCanvas: aCanvas usingFrame: (aDaliotsFrame leftPart: weightedXVector).
	rightPicture drawOnCanvas: aCanvas usingFrame: (aDaliotsFrame rightPart: weightedXVector)! !

!WeightedPictureBesidePicture methodsFor: 'accessing' stamp: 'hjo 3/5/2008 17:12'!
leftWeight: aNumber

	leftWeight :=aNumber! !

!WeightedPictureBesidePicture methodsFor: 'accessing' stamp: 'hjo 3/5/2008 17:13'!
rightWeight: aNumber

	rightWeight :=aNumber! !

FunctionalWoodCutPicture subclass: #PictureNonet
	instanceVariableNames: 'northWest north northEast west middle east southWest south southEast'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-ComplexFunctions'!

!PictureNonet methodsFor: 'drawing' stamp: 'hjo 3/5/2008 17:20'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression
		drawOnCanvas: aCanvas usingFrame: aDaliotsFrame
! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:58'!
east

	^ east! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:59'!
east: aWoodCutPicture

	east := aWoodCutPicture! !

!PictureNonet methodsFor: 'creation' stamp: 'hjo 3/6/2008 11:34'!
equivalentExpression

	^WeightedPictureAbovePicture new
		upWeight: 1;
		downWeight: 2;
		upPicture: (self equivalentExpressionRowWith: northWest with: north with: northEast);
		downPicture: 
			(PictureAbovePicture new
				upPicture: (self equivalentExpressionRowWith: west with: middle with: east);
				downPicture: (self equivalentExpressionRowWith: southWest with: south with: southEast)
			)
		! !

!PictureNonet methodsFor: 'creation' stamp: 'hjo 3/6/2008 11:23'!
equivalentExpressionRowWith: picture1 with: picture2 with: picture3
		
	^WeightedPictureBesidePicture new
		leftWeight: 1;
		rightWeight: 2;
		leftPicture: picture1;
		rightPicture: 
			(PictureBesidePicture new
				leftPicture: picture2;
				rightPicture: picture3
			)
		! !

!PictureNonet methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:07'!
functionName

	^'nonet'! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:59'!
middle

	^ middle! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:59'!
middle: aWoodCutPicture

	middle := aWoodCutPicture! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:59'!
north

	^ north! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:00'!
north: aWoodCutPicture

	north := aWoodCutPicture! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:00'!
northEast

	^ northEast! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:00'!
northEast: aWoodCutPicture

	northEast := aWoodCutPicture! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:00'!
northWest

	^ northWest! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:01'!
northWest: aWoodCutPicture

	northWest := aWoodCutPicture! !

!PictureNonet methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:08'!
parameterList

	^{ northWest. north. northEast.
	   west.  middle.  east.
	   southWest. south. southEast }! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:01'!
south

	^ south! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:01'!
south: aWoodCutPicture

	south := aWoodCutPicture! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:01'!
southEast

	^ southEast! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:02'!
southEast: aWoodCutPicture

	southEast := aWoodCutPicture! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:02'!
southWest

	^ southWest! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:02'!
southWest: aWoodCutPicture

	southWest := aWoodCutPicture! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:02'!
west

	^ west! !

!PictureNonet methodsFor: 'accessing' stamp: 'hjo 3/5/2008 16:02'!
west: anObject

	west := anObject! !

FunctionalWoodCutPicture subclass: #PictureOverPicture
	instanceVariableNames: 'overPicture underPicture frame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Functions'!

!PictureOverPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 10:33'!
drawOnCanvas: aFormCanvas usingFrame: aDaliotsFrame 

	underPicture drawOnCanvas: aFormCanvas usingFrame: aDaliotsFrame.
	overPicture drawOnCanvas: aFormCanvas usingFrame: aDaliotsFrame ! !

!PictureOverPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:09'!
functionName

	^'over'! !

!PictureOverPicture methodsFor: 'accessing' stamp: 'hjo 3/4/2008 08:39'!
overPicture: aWoodCutPicture 

	overPicture :=aWoodCutPicture! !

!PictureOverPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:10'!
parameterList

	^{overPicture. underPicture}! !

!PictureOverPicture methodsFor: 'accessing' stamp: 'hjo 3/4/2008 08:39'!
underPicture: aWoodCutPicture 

	underPicture :=aWoodCutPicture! !

FunctionalWoodCutPicture subclass: #PictureQuartet
	instanceVariableNames: 'upperLeftPicture upperRightPicture lowerLeftPicture lowerRightPicture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-ComplexFunctions'!

!PictureQuartet methodsFor: 'drawing' stamp: 'hjo 3/6/2008 17:02'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 

	self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame ! !

!PictureQuartet methodsFor: 'creation' stamp: 'hjo 3/6/2008 17:02'!
equivalentExpression

	^(upperLeftPicture beside: upperRightPicture) above: (lowerLeftPicture beside: lowerRightPicture)! !

!PictureQuartet methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:00'!
functionName

	^'quartet'! !

!PictureQuartet methodsFor: 'accessing' stamp: 'hjo 3/9/2008 12:22'!
lowerLeftPicture: aWoodCutPicture 

	lowerLeftPicture := aWoodCutPicture 
! !

!PictureQuartet methodsFor: 'accessing' stamp: 'hjo 3/9/2008 12:22'!
lowerRightPicture: aWoodCutPicture 

	lowerRightPicture := aWoodCutPicture ! !

!PictureQuartet methodsFor: 'printing' stamp: 'hjo 3/9/2008 12:25'!
parameterList
	
	^{ upperLeftPicture. upperRightPicture. lowerLeftPicture. lowerRightPicture }! !

!PictureQuartet methodsFor: 'accessing' stamp: 'hjo 3/9/2008 12:22'!
upperLeftPicture: aWoodCutPicture 

	upperLeftPicture := aWoodCutPicture ! !

!PictureQuartet methodsFor: 'accessing' stamp: 'hjo 3/9/2008 12:22'!
upperRightPicture: aWoodCutPicture 

	upperRightPicture := aWoodCutPicture ! !

FunctionalWoodCutPicture subclass: #SierpinskiPicture
	instanceVariableNames: 'subPicture blank'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-ComplexFunctions'!

!SierpinskiPicture methodsFor: 'accessing' stamp: 'hjo 3/13/2008 19:06'!
blank: aWoodCutPicture

	blank := aWoodCutPicture! !

!SierpinskiPicture methodsFor: 'drawing' stamp: 'hjo 3/13/2008 18:50'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame! !

!SierpinskiPicture methodsFor: 'creation' stamp: 'hjo 3/13/2008 19:05'!
enhance

	^self copy subPicture: self; blank: blank		! !

!SierpinskiPicture methodsFor: 'creation' stamp: 'hjo 3/13/2008 19:07'!
equivalentExpression

	^(subPicture beside: blank) above: (subPicture beside: subPicture)! !

!SierpinskiPicture methodsFor: 'printing' stamp: 'hjo 3/13/2008 19:12'!
functionName

	^'sierpinski'! !

!SierpinskiPicture methodsFor: 'printing' stamp: 'hjo 3/13/2008 19:13'!
parameterList

	^ { self unitPicture. blank. WoodCutNumber value: self sierpinskiDepth }! !

!SierpinskiPicture methodsFor: 'accessing' stamp: 'hjo 3/13/2008 19:10'!
sierpinskiDepth

	^subPicture sierpinskiDepth + 1! !

!SierpinskiPicture methodsFor: 'accessing' stamp: 'hjo 3/13/2008 19:06'!
subPicture: aWoodCutPicture

	subPicture := aWoodCutPicture! !

!SierpinskiPicture methodsFor: 'accessing' stamp: 'hjo 3/13/2008 19:04'!
unitPicture

	^subPicture unitPicture! !

FunctionalWoodCutPicture subclass: #UnaryFunctionalWoodCutPicture
	instanceVariableNames: 'picture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Core'!

UnaryFunctionalWoodCutPicture subclass: #FlippedPicture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Functions'!

!FlippedPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 11:21'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	picture drawOnCanvas: aCanvas usingFrame: aDaliotsFrame flippedFrame! !

!FlippedPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:50'!
functionName

	^'flip'! !

!FlippedPicture methodsFor: 'organizing' stamp: 'hjo 3/9/2008 14:02'!
simplified

	^picture class = self class
		ifTrue: [picture picture]
		ifFalse: [self]! !

UnaryFunctionalWoodCutPicture subclass: #PictureCycle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-ComplexFunctions'!

!PictureCycle methodsFor: 'drawing' stamp: 'hjo 3/6/2008 17:01'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame 

	self equivalentExpression
		drawOnCanvas: aCanvas usingFrame: aDaliotsFrame ! !

!PictureCycle methodsFor: 'creation' stamp: 'hjo 3/9/2008 10:24'!
equivalentExpression

	^PictureQuartet new
		upperLeftPicture: picture;
		upperRightPicture: picture rotated rotated rotated ;
		lowerLeftPicture: picture rotated;
		lowerRightPicture: picture rotated rotated! !

!PictureCycle methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:59'!
functionName

	^'cycle'! !

UnaryFunctionalWoodCutPicture subclass: #RotatedBy45DegreesPicture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Functions'!

!RotatedBy45DegreesPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 11:43'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	picture drawOnCanvas: aCanvas usingFrame: aDaliotsFrame rotatedBy45Degrees! !

!RotatedBy45DegreesPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:54'!
functionName

	^'rot45'! !

UnaryFunctionalWoodCutPicture subclass: #RotatedPicture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Functions'!

!RotatedPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 11:16'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	picture drawOnCanvas: aCanvas usingFrame: aDaliotsFrame rotatedFrame! !

!RotatedPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:55'!
functionName

	^'rot'! !

!RotatedPicture methodsFor: 'organizing' stamp: 'hjo 3/9/2008 14:01'!
simplified

	^(picture class = self class and: [
	picture picture class = self class and: [
	picture picture picture class = self class
	]])
		ifTrue: [picture picture picture picture]
		ifFalse: [self]! !

!UnaryFunctionalWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 20:28'!
borderColor

	^picture borderColor
	! !

!UnaryFunctionalWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 20:28'!
borderWidth

	^picture borderWidth! !

!UnaryFunctionalWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 20:28'!
fillColor

	^picture fillColor! !

!UnaryFunctionalWoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:51'!
parameterList

	^{ picture }! !

!UnaryFunctionalWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 20:28'!
picture

	^picture! !

!UnaryFunctionalWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 20:28'!
picture: aWoodCutPicture 

	picture :=aWoodCutPicture! !

!UnaryFunctionalWoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/29/2008 20:29'!
shape

	^picture shape! !

UnaryFunctionalWoodCutPicture subclass: #WoodCutTileT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Squarelimit'!

!WoodCutTileT methodsFor: 'drawing' stamp: 'hjo 3/6/2008 16:21'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame! !

!WoodCutTileT methodsFor: 'creating' stamp: 'hjo 3/6/2008 16:21'!
equivalentExpression

	| the2 the3 |
	the2 := picture pattern2.
	the3 := the2 triplyRotated.
	^picture over: (the2 over: the3)! !

!WoodCutTileT methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:52'!
functionName

	^'t'! !

UnaryFunctionalWoodCutPicture subclass: #WoodCutTileU
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Squarelimit'!

!WoodCutTileU methodsFor: 'drawing' stamp: 'hjo 3/6/2008 16:29'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame! !

!WoodCutTileU methodsFor: 'creation' stamp: 'hjo 3/6/2008 16:31'!
equivalentExpression

	| the2 |
	the2 := picture pattern2.
	^(the2 over: the2 rotated) over:
		(the2 rotated rotated over: the2 rotated rotated rotated)
	! !

!WoodCutTileU methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:53'!
functionName

	^'u'! !

UnaryFunctionalWoodCutPicture subclass: #WoodCutTileV
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Squarelimit'!

!WoodCutTileV methodsFor: 'drawing' stamp: 'hjo 3/9/2008 10:26'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame! !

!WoodCutTileV methodsFor: 'creation' stamp: 'hjo 3/9/2008 10:37'!
equivalentExpression

	^picture tileTForm rotated cycled! !

!WoodCutTileV methodsFor: 'printing' stamp: 'hjo 3/9/2008 10:27'!
functionName

	^'v'! !

FunctionalWoodCutPicture subclass: #WoodCutCorner
	instanceVariableNames: 'exCorner exSide tileU'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Squarelimit'!

!WoodCutCorner methodsFor: 'drawing' stamp: 'hjo 3/6/2008 17:05'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	^self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame
! !

!WoodCutCorner methodsFor: 'creation' stamp: 'hjo 3/6/2008 16:49'!
enhance

	^self copy
		exCorner: self;
		exSide: (exSide buildSide: (tileU picture tileTForm))! !

!WoodCutCorner methodsFor: 'creation' stamp: 'hjo 3/6/2008 16:42'!
enhanceWithExSide: aWoodCutPicture

	^self copy
		exCorner: self;
		exSide: aWoodCutPicture! !

!WoodCutCorner methodsFor: 'creation' stamp: 'hjo 3/6/2008 17:04'!
equivalentExpression

	^PictureQuartet new
		upperLeftPicture: exCorner;
		upperRightPicture: exSide;
		lowerLeftPicture: exSide rotated;
		lowerRightPicture: tileU! !

!WoodCutCorner methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:26'!
exCorner: aWoodCutPicture

	exCorner := aWoodCutPicture! !

!WoodCutCorner methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:26'!
exSide: aWoodCutPicture

	exSide := aWoodCutPicture! !

!WoodCutCorner methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:10'!
functionName

	^'corner'! !

!WoodCutCorner methodsFor: 'printing' stamp: 'hjo 3/9/2008 12:15'!
parameterList

	^{ tileU picture. WoodCutNumber value: self structureDepth }! !

!WoodCutCorner methodsFor: 'accessing' stamp: 'hjo 3/9/2008 12:15'!
structureDepth
	
	^exCorner structureDepth + 1! !

!WoodCutCorner methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:25'!
tileU: aWoodCutPicture

	tileU :=aWoodCutPicture! !

FunctionalWoodCutPicture subclass: #WoodCutSide
	instanceVariableNames: 'exSide tileT'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Squarelimit'!

!WoodCutSide methodsFor: 'drawing' stamp: 'hjo 3/6/2008 17:06'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression
		drawOnCanvas: aCanvas usingFrame: aDaliotsFrame! !

!WoodCutSide methodsFor: 'creation' stamp: 'hjo 3/5/2008 15:22'!
enhance

	^self copy
		exSide: self! !

!WoodCutSide methodsFor: 'creation' stamp: 'hjo 3/6/2008 17:06'!
equivalentExpression

	^PictureQuartet new
		upperLeftPicture: exSide;
		upperRightPicture: exSide;
		lowerLeftPicture: tileT rotated;
		lowerRightPicture: tileT! !

!WoodCutSide methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:13'!
exSide: aWoodCutPicture

	exSide := aWoodCutPicture! !

!WoodCutSide methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:12'!
functionName

	^'side'! !

!WoodCutSide methodsFor: 'printing' stamp: 'hjo 3/9/2008 12:14'!
parameterList

	^{ tileT picture. WoodCutNumber value: self structureDepth }! !

!WoodCutSide methodsFor: 'accessing' stamp: 'hjo 3/9/2008 11:36'!
structureDepth

	^exSide structureDepth + 1! !

!WoodCutSide methodsFor: 'accessing' stamp: 'hjo 3/5/2008 15:13'!
tileT: aWoodCutPicture

	tileT := aWoodCutPicture! !

FunctionalWoodCutPicture subclass: #WoodCutSquareLimit
	instanceVariableNames: 'corner side tileU'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Squarelimit'!

!WoodCutSquareLimit class methodsFor: 'as yet unclassified' stamp: 'hjo 3/9/2008 11:19'!
picture: aWoodCutPicture

	| blank u |
	blank := WoodCutPicture blank.
	u := aWoodCutPicture tileUForm.
	^self new
		tileU: u;
		side: (WoodCutSide new tileT: aWoodCutPicture tileTForm; exSide: blank);
		corner: (WoodCutCorner new exCorner: blank; exSide: blank; tileU: u)! !

!WoodCutSquareLimit methodsFor: 'accessing' stamp: 'hjo 3/9/2008 11:10'!
corner: aWoodCutPicture

	corner := aWoodCutPicture! !

!WoodCutSquareLimit methodsFor: 'drawing' stamp: 'hjo 3/6/2008 16:15'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	self equivalentExpression drawOnCanvas: aCanvas usingFrame: aDaliotsFrame! !

!WoodCutSquareLimit methodsFor: 'creation' stamp: 'hjo 3/6/2008 16:45'!
enhance
	
	^self copy
		side: side enhance;
		corner: (corner enhanceWithExSide: side)! !

!WoodCutSquareLimit methodsFor: 'creation' stamp: 'hjo 3/6/2008 12:46'!
equivalentExpression

	| nonet tempSide tempCorner |
	nonet := PictureNonet new.
	nonet middle: tileU.
	
	"rotation 0"
	tempSide := side.
	tempCorner := corner.
	nonet 
		northWest: tempCorner;
		north: tempSide.

	"rotation 1"
	tempSide := tempSide rotated.
	tempCorner := tempCorner rotated.
	nonet
		west: tempSide;
		southWest: tempCorner.
	
	"rotation 2"
	tempSide := tempSide rotated.
	tempCorner := tempCorner rotated.
	nonet
		south: tempSide;
		southEast: tempCorner.
	
	"rotatiton 3"
	tempSide := tempSide rotated.
	tempCorner := tempCorner rotated.
	nonet
		east: tempSide;
		northEast: tempCorner.
	
	^nonet
	! !

!WoodCutSquareLimit methodsFor: 'printing' stamp: 'hjo 3/6/2008 19:14'!
functionName

	^'squarelimit'! !

!WoodCutSquareLimit methodsFor: 'printing' stamp: 'hjo 3/9/2008 12:00'!
parameterList

	^ { tileU picture. WoodCutNumber value: self structureDepth }! !

!WoodCutSquareLimit methodsFor: 'accessing' stamp: 'hjo 3/6/2008 15:47'!
side: aWoodCutPicture

	side := aWoodCutPicture! !

!WoodCutSquareLimit methodsFor: 'accessing' stamp: 'hjo 3/9/2008 11:35'!
structureDepth

	^side structureDepth! !

!WoodCutSquareLimit methodsFor: 'accessing' stamp: 'hjo 3/6/2008 16:15'!
tileU

	^tileU! !

!WoodCutSquareLimit methodsFor: 'accessing' stamp: 'hjo 3/6/2008 15:47'!
tileU: aWoodCutPicture

	tileU := aWoodCutPicture! !

AbstractWoodCutPicture subclass: #WoodCutPicture
	instanceVariableNames: 'shape name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Core'!

!WoodCutPicture class methodsFor: 'instance creation' stamp: 'hjo 3/6/2008 18:05'!
blank

	^self new shape: {}; name: 'blank'! !

!WoodCutPicture class methodsFor: 'instance creation' stamp: 'hjo 3/7/2008 15:32'!
f

	^self new
		shape: self fShape;
		name: 'f'! !

!WoodCutPicture class methodsFor: 'instance creation' stamp: 'hjo 3/6/2008 18:11'!
fShape
	
	| scale ux uy p nux nuy |
	scale := 1/7.
	ux := (1@0) *scale.
	uy := (0@1) *scale.
	nux := ux negated.
	nuy := uy negated.
	
	p := 0@0.

	^{
		ux + ux + uy.
		ux + ux +ux.
		uy.
		nux + nux.
		uy.
		ux.
		uy.
		nux.
		uy + uy.
		nux.
		nuy + nuy + nuy + nuy + nuy
	} collect: [:jump| p := p + jump ]
	! !

!WoodCutPicture class methodsFor: 'instance creation' stamp: 'hjo 3/7/2008 15:49'!
fish

	^self new
		shape: self fishShape;
		name: 'fish'! !

!WoodCutPicture class methodsFor: 'instance creation' stamp: 'hjo 3/9/2008 09:26'!
fishShape

	"^{4@0. 3.5@5.5. 0@10. 4@13. 7@10. 11@13. 17@13. 14@10. 10.5@10. 10.5@3. 7@2.5} / (20@20)"
	"^ {0.17@0.18 . 0.145@0.455 . -0.03@0.68 . 0.17@0.83 . 0.32@0.68 . 0.52@0.83 . 0.82@0.83 . 0.67@0.68 . 0.495@0.68 . 0.495@0.33 . 0.32@0.305}"
	 "^{0.03073169484375002@0.0999422153125 . -0.002770696171874986@0.468468516484375 . -0.23728743328125@0.769990035625 . 0.03073169484375002@0.97100438171875 . 0.2317460409374999@0.769990035625 . 0.4997651690625@0.97100438171875 . 0.90179386125@0.97100438171875 . 0.70077951515625@0.769990035625 . 0.466262778046875@0.769990035625 . 0.466262778046875@0.30095656140625 . 0.2317460409374999@0.267454170390625}"
	^ {-0.01442422175650387@0.00569560700113284 . -0.0532074271559668@0.4323108663952245 . -0.324689864952207@0.781359714990391 . -0.01442422175650387@1.014058947387168 . 0.2182750106402733@0.781359714990391 . 0.528540653835977@1.014058947387168 . 0.993939118629531@1.014058947387168 . 0.761239886232754@0.781359714990391 . 0.4897574484365137@0.781359714990391 . 0.4897574484365137@0.23839483939791 . 0.2182750106402733@0.1996116339984472}! !

!WoodCutPicture class methodsFor: 'instance creation' stamp: 'HwaJong 10/28/2013 00:00'!
triangle

	^self new shape: { 0@0. 1@1. 0@1 }; name: 'triangle'! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 11:23'!
borderColor

	^Color black! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 11:22'!
borderWidth

	^1! !

!WoodCutPicture methodsFor: 'drawing' stamp: 'hjo 3/4/2008 20:46'!
drawOnCanvas: aCanvas usingFrame: aDaliotsFrame

	shape isEmpty ifFalse: [ 
		aCanvas 
			drawPolygon: (aDaliotsFrame mappedPoints: shape) 
			color: self fillColor
			borderWidth: self borderWidth
			borderColor: self borderColor
	]! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 11:22'!
fillColor

	^Color red! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 3/6/2008 18:04'!
name: aString

	name := aString! !

!WoodCutPicture methodsFor: 'printing' stamp: 'hjo 3/6/2008 18:04'!
printExpressionOn: aStream

	aStream nextPutAll: (name isNil ifTrue: ['<unnamed>'] ifFalse: [name])! !

!WoodCutPicture methodsFor: 'shape change' stamp: 'hjo 3/7/2008 23:24'!
scaleBy: aFloat 

	shape := shape * aFloat! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 11:41'!
shape

	^shape! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 2/23/2008 11:15'!
shape: anArray

	shape := anArray! !

!WoodCutPicture methodsFor: 'accessing' stamp: 'hjo 3/9/2008 11:36'!
structureDepth

	^0! !

!WoodCutPicture methodsFor: 'shape change' stamp: 'hjo 3/7/2008 17:09'!
translate: aPoint

	shape := shape + aPoint! !

Object subclass: #FramedPicture
	instanceVariableNames: 'picture frame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Shows'!

!FramedPicture methodsFor: 'drawing' stamp: 'hjo 3/6/2008 18:15'!
drawOn: aCanvas

	picture drawOnCanvas: aCanvas usingFrame: frame.
	aCanvas drawString: picture expressionString at: frame origin + frame yVector! !

!FramedPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 11:18'!
flipped

	^self copy picture: picture flipped! !

!FramedPicture methodsFor: 'accessing' stamp: 'hjo 3/4/2008 11:16'!
frame: aDaliotsFrame 

	frame := aDaliotsFrame! !

!FramedPicture methodsFor: 'accessing' stamp: 'hjo 3/4/2008 11:26'!
picture

	^picture! !

!FramedPicture methodsFor: 'accessing' stamp: 'hjo 3/4/2008 11:15'!
picture: aWoodCutPicture 

	picture := aWoodCutPicture! !

!FramedPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 11:12'!
rotated

	^self copy
		picture: picture rotated! !

!FramedPicture methodsFor: 'decorating short cut' stamp: 'hjo 3/4/2008 11:42'!
rotatedBy45Degrees

	^self copy picture: picture rotatedBy45Degrees! !

Object subclass: #WoodCutFrame
	instanceVariableNames: 'origin xVector yVector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Core'!

!WoodCutFrame class methodsFor: 'as yet unclassified' stamp: 'hjo 2/22/2008 22:16'!
ofWorld

	| wb |
	wb := World bounds.
	^self new
		origin: wb origin;
		xVector: wb topRight;
		yVector: wb bottomLeft! !

!WoodCutFrame methodsFor: 'dividing frame' stamp: 'hjo 2/26/2008 23:24'!
downHalf

	^self copy
		origin: (origin + (yVector / 2 ));
		yVector: yVector / 2! !

!WoodCutFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 12:06'!
downPart: yVectorOfUpPart

	^self copy
		origin: origin + yVectorOfUpPart;
		yVector: yVector - yVectorOfUpPart! !

!WoodCutFrame methodsFor: 'transformed frames' stamp: 'hjo 2/26/2008 22:53'!
flippedFrame

	^self species new
		origin: self origin + self xVector;
		xVector: self xVector negated;
		yVector: self yVector! !

!WoodCutFrame methodsFor: 'testing' stamp: 'hjo 3/7/2008 11:33'!
isRightAngle

	^(xVector crossProduct: yVector) > 0! !

!WoodCutFrame methodsFor: 'dividing frame' stamp: 'hjo 2/29/2008 05:36'!
leftHalf

	^self copy
		xVector: self xVector / 2! !

!WoodCutFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 11:49'!
leftPart: leftXVector

	^self copy
		xVector:leftXVector! !

!WoodCutFrame methodsFor: 'converting' stamp: 'hjo 2/29/2008 20:20'!
mappedPoint: aPoint 

	^((aPoint x * self xVector) + (aPoint y * self yVector) + self origin) truncated! !

!WoodCutFrame methodsFor: 'converting' stamp: 'hjo 2/29/2008 20:20'!
mappedPoints: anArray 

	^anArray collect: [:point| self mappedPoint: point ]! !

!WoodCutFrame methodsFor: 'accessing' stamp: 'hjo 2/22/2008 21:38'!
origin

	^origin! !

!WoodCutFrame methodsFor: 'accessing' stamp: 'hjo 2/22/2008 22:12'!
origin: aPoint 

	origin := aPoint! !

!WoodCutFrame methodsFor: 'dividing frame' stamp: 'hjo 2/29/2008 05:38'!
rightHalf

	|halfX|
	halfX := xVector / 2.
	^self copy
		origin: self origin + halfX;
		xVector: halfX! !

!WoodCutFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 11:59'!
rightPart: xVectorOfLeftPart

	^self copy
		origin: origin + xVectorOfLeftPart;
		xVector: xVector - xVectorOfLeftPart! !

!WoodCutFrame methodsFor: 'transformed frames' stamp: 'hjo 3/9/2008 12:20'!
rotatedBy45Degrees

	^self copy
		xVector: (xVector - yVector) / 2;
		yVector: (xVector + yVector) / 2
! !

!WoodCutFrame methodsFor: 'transformed frames' stamp: 'hjo 3/7/2008 11:34'!
rotatedFrame

	^self isRightAngle
		ifTrue: 
			[self copy
				origin: origin + yVector;
				xVector: yVector negated;
				yVector: xVector]
		ifFalse: 
			[self copy
				origin: origin + xVector;
				xVector: yVector;
				yVector: xVector negated]! !

!WoodCutFrame methodsFor: 'dividing frame' stamp: 'hjo 2/26/2008 23:21'!
upHalf

	^self copy yVector: self yVector / 2! !

!WoodCutFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 11:55'!
upPart: aPoint 

	^self copy yVector: aPoint! !

!WoodCutFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 12:09'!
vector: aVector weightedBy: weight1 and: weight2 

	^(((0@0) * weight2) + (aVector * weight1)) / (weight1 + weight2)! !

!WoodCutFrame methodsFor: 'accessing' stamp: 'hjo 2/22/2008 21:39'!
xVector

	^xVector! !

!WoodCutFrame methodsFor: 'accessing' stamp: 'hjo 2/22/2008 22:16'!
xVector: aPoint 
	
	xVector := aPoint! !

!WoodCutFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 12:08'!
xVectorWeightedBy: leftWeight and: rightWeight 

	^self vector: xVector weightedBy: leftWeight and: rightWeight! !

!WoodCutFrame methodsFor: 'accessing' stamp: 'hjo 2/22/2008 21:39'!
yVector

	^yVector! !

!WoodCutFrame methodsFor: 'accessing' stamp: 'hjo 2/22/2008 22:17'!
yVector: aPoint 

	yVector := aPoint! !

!WoodCutFrame methodsFor: 'dividing frame' stamp: 'hjo 3/6/2008 12:10'!
yVectorWeightedBy: topWeight and: bottomWeight

	^self vector: yVector weightedBy: topWeight and: bottomWeight! !

Object subclass: #WoodCutNumber
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Core'!

!WoodCutNumber class methodsFor: 'instance creation' stamp: 'hjo 3/9/2008 11:40'!
value: aSmallInteger 

	^self new value: aSmallInteger! !

!WoodCutNumber methodsFor: 'printing' stamp: 'hjo 3/9/2008 11:41'!
printExpressionOn: aWriteStream 
	
	aWriteStream print: value! !

!WoodCutNumber methodsFor: 'accessing' stamp: 'hjo 3/9/2008 11:40'!
value: aSmallInteger 

	value := aSmallInteger! !

Object subclass: #WoodCutShow
	instanceVariableNames: 'framedPictures unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Shows'!

WoodCutShow subclass: #BasicTestShow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Shows'!

!BasicTestShow methodsFor: 'drawing-layout' stamp: 'hjo 3/7/2008 16:55'!
frameSize

	"size of default square frame size."
	^60! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 10:44'!
install

	framedPictures := OrderedCollection new.
	
	self installRot.
	self installFlip.
	self installFlipRot.
	self installRotFlip.
	self installAbove.
	self installBeside.
	self installBesideAbove.
	self installRot45.
	self installRot45Flip.
	self installOver.
	self installBasicTwice.
	self installTiles.
	self installQuartet.
	self installCycle.
	self installSide.
	self installCorner.
	self installNonet.
	self installSquareLimit! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:35'!
installAbove

	self add: unit coordination: 0@4.
	self add: (unit above: unit) coordination: 1@4! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:35'!
installBasicTwice

	self add: 
		(PictureOverPicture new
			underPicture: unit;
			overPicture: unit rotated rotated)
		coordination: 6@0! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:36'!
installBeside

	self add: unit coordination: 3@4.
	self add: (unit beside: unit) coordination: 4@4! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:36'!
installBesideAbove

	framedPictures add:
		(FramedPicture new
			picture: ((unit beside: unit) above: unit);
			frame: (self coordinatedFrame: 6@4))
! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:36'!
installCorner

	| blank corner |
	blank := WoodCutPicture blank.
	corner := WoodCutCorner new
		exCorner: blank;
		exSide: blank;
		tileU: unit tileUForm.
	
	self add: corner coordination: 8@1.
	corner := corner enhance.
	self add: corner coordination: 10@1.
	corner := corner enhance.
	self add: corner coordination: 12@1.
	corner := corner enhance.
	self add: corner coordination: 14@1.
	! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 09:54'!
installCycle

	self add: (PictureCycle new picture: unit) coordination: 2@6
! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:36'!
installFlip

	self add: unit coordination: 0@1.
	self add: unit flipped coordination: 1@1.
	self add: unit flipped flipped coordination: 2@1! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:36'!
installFlipRot

	self add: unit coordination: 0@2.
	self add: unit flipped coordination: 1@2.
	self add: unit flipped rotated coordination: 2@2.
! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 12:18'!
installNonet

	self add: (PictureNonet new
		northWest: unit; north: unit; northEast: unit;
		west: unit; middle: unit; east: unit;
		southWest: unit; south: unit; southEast: unit) coordination: 4@6! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installOver

	self add: (unit rotatedBy45Degrees over: unit) coordination: 4@3! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installQuartet

	self add: (PictureQuartet new
		upperLeftPicture: unit;
		upperRightPicture: unit;
		lowerLeftPicture: unit;
		lowerRightPicture: unit) coordination: 0@6.
! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installRot

	self add: unit coordination: 0@0.
	self add: unit rotated coordination: 1@0.
	self add: unit rotated rotated coordination: 2@0.
	self add: unit rotated rotated rotated coordination: 3@0.
	self add: unit rotated rotated rotated rotated coordination: 4@0! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installRot45

	self add: unit rotatedBy45Degrees coordination: 4@1! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installRot45Flip

	self add: unit flipped rotatedBy45Degrees coordination: 5@1! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installRotFlip

	self add: unit coordination: 0@3.
	self add: unit rotated coordination: 1@3.
	self add: unit rotated flipped coordination: 2@3
	! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installSide

	| side |
	side := WoodCutSide new.
	side exSide: WoodCutPicture blank.
	side tileT: unit tileTForm.
	self add: side coordination: 8@0.
	side := side enhance.
	self add: side coordination: 10@0.
	side := side enhance.
	self add: side coordination: 12@0.
	side := side enhance.
	self add: side coordination: 14@0.
	
! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 12:19'!
installSquareLimit

	| sl |
	sl := WoodCutSquareLimit picture: unit.
	self add: sl coordination: 8@2.
	sl := sl enhance.
	self add: sl coordination: 10@2.
	sl := sl enhance.
	self add: sl coordination: 12@2.
	sl := sl enhance.
	self add: sl coordination: 14@2.! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:37'!
installTileTAndU

	| the2 the3 t |
	the2 := unit pattern2.
	the3 := the2 triplyRotated.
	t := unit tileTForm.
	
	self add: the2 coordination: 0@5.
	self add: the3 coordination: 1@5.
	self add: t coordination: 2@5.
	self add: unit tileUForm coordination: 4@5! !

!BasicTestShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 10:46'!
installTiles

	| the2 the3 t |
	the2 := unit pattern2.
	the3 := the2 triplyRotated.
	t := unit tileTForm.
	
	self add: the2 coordination: 0@5.
	self add: the3 coordination: 1@5.
	self add: t coordination: 2@5.
	self add: unit tileUForm coordination: 4@5.
	self add: unit tileVForm coordination: 6@5! !

WoodCutShow subclass: #FishTileFittingShow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Shows'!

!FishTileFittingShow methodsFor: 'drawing-layout' stamp: 'hjo 3/7/2008 16:56'!
frameSize

	"size of default square frame size."
	^120! !

!FishTileFittingShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 12:32'!
install

	framedPictures := OrderedCollection new.
	
	self installSimple.
	self installSquareLimit
! !

!FishTileFittingShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 12:31'!
installSimple

	self add: unit coordination: 1@1.
	self add: (unit over: unit rotated rotated) coordination: 3@1.
	self add: unit tileTForm coordination: 5@1.
	self add: unit tileUForm coordination: 7@1.
	self add: unit tileUForm quartetOfOne coordination: 1@2.
	self add: unit tileVForm coordination: 3@2.
	self add: unit tileVForm quartetOfOne coordination: 5@2
! !

!FishTileFittingShow methodsFor: 'initialize-release' stamp: 'hjo 3/9/2008 12:41'!
installSquareLimit

	| sl |
	sl := WoodCutSquareLimit picture: unit.
	self add: sl coordination: 1@3.

	sl := sl enhance.
	self add: sl coordination: 3@3.

	sl := sl enhance.
	self add: sl coordination: 5@3.

	sl := sl enhance.
	self add: sl coordination: 7@3
! !

WoodCutShow subclass: #SierpinskiShow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'WoodCutPictures-Shows'!

!SierpinskiShow methodsFor: 'drawing-layout' stamp: 'hjo 3/13/2008 19:24'!
frameSize

	^120! !

!SierpinskiShow methodsFor: 'initialize-release' stamp: 'HwaJong 10/28/2013 00:01'!
install

	| sier |
	framedPictures := OrderedCollection new.
	
	sier := SierpinskiPicture new subPicture: unit; blank: WoodCutPicture blank.
	self add: sier coordination: 1@1.
	sier := sier enhance.
	self add: sier coordination: 3@1.
	sier := sier enhance.
	self add: sier coordination: 5@1.
	sier := sier enhance.
	self add: sier coordination: 7@1.
! !

!WoodCutShow class methodsFor: 'instance creation' stamp: 'hjo 3/9/2008 12:01'!
f

	^self new unit: WoodCutPicture f! !

!WoodCutShow class methodsFor: 'instance creation' stamp: 'hjo 3/9/2008 12:01'!
fish

	^self new unit: WoodCutPicture fish! !

!WoodCutShow class methodsFor: 'instance creation' stamp: 'hjo 3/13/2008 19:48'!
triangle

	^self new unit: WoodCutPicture triangle! !

!WoodCutShow class methodsFor: 'example' stamp: 'HwaJong 10/28/2013 01:13'!
yeah

Display restore.
FishTileFittingShow triangle install paint.
SierpinskiShow triangle install paint.
SierpinskiShow f install paint.
SierpinskiShow fish install paint.! !

!WoodCutShow methodsFor: 'drawing-layout' stamp: 'hjo 3/7/2008 16:31'!
add: aWoodCutPicture coordination: coordination

	framedPictures add: (FramedPicture new picture: aWoodCutPicture; frame: (self coordinatedFrame: coordination))! !

!WoodCutShow methodsFor: 'drawing-layout' stamp: 'hjo 3/4/2008 10:55'!
coordinatedFrame: coordination

	^self defaultFrame
		origin: (self frameOriginForCoordination: coordination)! !

!WoodCutShow methodsFor: 'drawing-layout' stamp: 'HwaJong 10/28/2013 15:32'!
defaultFrame

	^WoodCutFrame new
		origin: 0@0;
		xVector: self frameSize@0;
		yVector: 0@self frameSize! !

!WoodCutShow methodsFor: 'drawing-layout' stamp: 'hjo 2/29/2008 06:35'!
frameOriginForCoordination: coordination

	^ (coordination x  @ (coordination y * (1+self yMargin)) * self frameSize) truncated! !

!WoodCutShow methodsFor: 'drawing-layout' stamp: 'hjo 3/4/2008 07:54'!
frameSize

	"size of default square frame size."
	^60! !

!WoodCutShow methodsFor: 'initialize-release' stamp: 'hjo 3/7/2008 16:52'!
install

	" build framedPicture list "
	self subclassResponsibility! !

!WoodCutShow methodsFor: 'drawing' stamp: 'hjo 3/7/2008 15:19'!
paint

	self paintOn: World canvas! !

!WoodCutShow methodsFor: 'drawing' stamp: 'hjo 3/7/2008 16:32'!
paintOn: aCanvas

	framedPictures do: [:pict| pict drawOn: aCanvas ].
! !

!WoodCutShow methodsFor: 'drawing' stamp: 'hjo 2/23/2008 16:48'!
restoreDisplay

	Display restore! !

!WoodCutShow methodsFor: 'accessing' stamp: 'hjo 3/7/2008 17:02'!
unit

	^unit! !

!WoodCutShow methodsFor: 'accessing' stamp: 'hjo 3/7/2008 14:47'!
unit: aWoodCutPicture

	unit := aWoodCutPicture! !

!WoodCutShow methodsFor: 'drawing-layout' stamp: 'hjo 2/29/2008 06:35'!
yMargin

	^0.5! !
